//----------------------------------------------------------------------------
//  Description :
//      preprocessor control class FSPreProc interface
//----------------------------------------------------------------------------
//  Changes:
//  $Log__$
//----------------------------------------------------------------------------

#ifndef FSPPROC_H
#define FSPPROC_H

#if !defined( _INC_STDLIB ) || !defined( FSBOOL_H )
   #error stdlib.h and fsbool.h required!
#endif

const FS_MAX_LINE_NUM_LEN = 10;

class FSFileStack;
class FSMacroTable;
class FSMacroCallStack;
class FSInputBuffer;
class FSOutBuffer;
class FSTokenizer;
class FSIfStack;

//##ModelId=419A04D501CC
class FSPreProc
{
	public:

	//##ModelId=419A04D501E1
		Boolean cppEnabled;
	//##ModelId=419A04D501EB
		Boolean nestedComments;
	//##ModelId=419A04D501F4
		char*& File() { return file; }
	//##ModelId=419A04D501F5
		unsigned& Line() { return line; }
	//##ModelId=419A04D501FE
      char *LineString() { return itoa( Line(), lineNumBuf, 10 ); }

	//##ModelId=419A04D501FF
      int GetToken();
	//##ModelId=419A04D50208
		FSPreProc( char *fileName );
	//##ModelId=419A04D50212
		~FSPreProc();

	private:

	//##ModelId=419A04D502DA
		friend int yylex();
	//##ModelId=419A04D50213
      char lineNumBuf[ FS_MAX_LINE_NUM_LEN + 1 ]; // needed for __LINE__
	//##ModelId=419A04D50227
		Boolean lineBeginning;
	//##ModelId=419A04D50231
		Boolean tokenIsSaved;
	//##ModelId=419A04D5023A
		int savedToken;
	//##ModelId=419A04D5024F
      Boolean passThroughNewline; // if true, GetToken() returns the NEWLINE token

	//##ModelId=419A04D50259
      unsigned line;
	//##ModelId=419A04D50262
      char* file;

	public:

	//##ModelId=419A04D50277
      FSFileStack &fileStack;
	//##ModelId=419A04D50281
      FSMacroTable &macroTable;
	//##ModelId=419A04D50295
      FSMacroCallStack &macroCallStack;
	//##ModelId=419A04D5029F
      FSInputBuffer &inputBuffer;
	//##ModelId=419A04D502B3
      FSOutBuffer &outBuffer;
	//##ModelId=419A04D502BD
      FSTokenizer &tokenizer;
	//##ModelId=419A04D502D1
      FSIfStack &ifStack;
};

// flex interface elements

extern FSPreProc *preProc;

//extern char *yytext;

//extern int yyleng;

//int yylex();
#endif
