//----------------------------------------------------------------------------
//  Description :
//      class FSAnlzOptions that holds parameter values for FS analysis
//----------------------------------------------------------------------------
//  Changes:
//  $Log__$
//----------------------------------------------------------------------------

#ifndef FSANZOPT_H
#define FSANZOPT_H

//##ModelId=419A04D600C9
typedef unsigned long FSAnlzMode; // 32 bit in all models
#define	FSM_MSC  1
#define	FSM_BC  2
#define	FSM_IAR  4
#define	FSM_ANSI  8
#define	FSM_KR  16
#define	FSM_C51  32
#define	FSM_C166  64
#define	FSM_ORG  128
#define   FSM_HW_HC5_11_12  256
#define   FSM_HW_HC16  512
#define   FSM_HW_851  1024
#define   FSM_HW_XA  2048
#define   FSM_HW_68K  4096

#define   FSM_COSMIC_6805  0x10000L
#define   FSM_HI_TECH_6805  0x20000L
#define   FSM_TMS_370  0x40000L

//##ModelId=419A04D600E7
extern class FSAnlzOptions
{
   public:

	//##ModelId=419A04D600F1
      FSAnlzMode GetMode() { return mode; }

	//##ModelId=419A04D600FB
      void SetMode( FSAnlzMode mde ) { mode = mde; }

	//##ModelId=419A04D60105
      Boolean GetCppComments() { return cppComments; }

	//##ModelId=419A04D60106
      void SetCppComments( Boolean cmnts ) { cppComments = cmnts; }

	//##ModelId=419A04D60110
      Boolean GetNestedComments() { return nestedComments; }

	//##ModelId=419A04D60119
      void SetNestedComments( Boolean cmnts ) { nestedComments = cmnts; }

	//##ModelId=419A04D60123
      char *GetStdLibIncludeDir() { return stdLibIncludeDir; }

	//##ModelId=419A04D60124
      void SetStdLibIncludeDir( char *newDir ) { stdLibIncludeDir = newDir; }

	//##ModelId=419A04D6012E
   FSAnlzOptions()
     : mode( FSM_BC ),
       cppComments( TRUE ),
       nestedComments( FALSE ),
       stdLibIncludeDir( "c:\\bc45\\include\\" )
   {}

   private:

	//##ModelId=419A04D60138
      FSAnlzMode mode;
	//##ModelId=419A04D60142
      Boolean cppComments;
	//##ModelId=419A04D60156
      Boolean nestedComments;
	//##ModelId=419A04D6015F
      char *stdLibIncludeDir; // !!! ovo ce posle biti lista direktorijuma
} fsAnlzOptions;

#else
   #error Already included!
#endif

