//----------------------------------------------------------------------------
//  Description :
//      lexical analyzer implementation
//----------------------------------------------------------------------------
//  Changes:
//  $Log__$
//----------------------------------------------------------------------------
#include <string.h>
#include <fstream.h>
#include <stdlib.h>
#ifdef PPDEBUG
   #include <iostream.h>
#endif

#ifdef DEBUG
   #ifdef BRANKO
      #include "debug.h"
   #endif
#endif

#include "fsbool.h"
#include "fsanzopt.h"
#include "fslex.h"
#include "fserror.h"
#include "fspproc.h"
#include "fsstacks.h"
#include "fstoken.h"
//#include "fssymtab.h"
// token definitions from yacc
#include "fspars_t.h"

char *yytext;
int yyleng;
extern YYSTYPE yylval;

Boolean typDfAllowed;

//##ModelId=419A04D6019B
class FSReservedIdRec
{
   public:
	//##ModelId=419A04D601A5
      char *Keyword;
	//##ModelId=419A04D601AF
      int tokenClass;
	//##ModelId=419A04D601B9
      int tokenVal;
	//##ModelId=419A04D601C4
      FSAnlzMode TokenFlags;
	//##ModelId=419A04D601CD
      Boolean Active();
};

#define FS_IDHASHSIZE 562
#define FS_IDHASHSTEP(Hash, c) (Hash * 40167 + c)
// position of some keywords in hashtable, bacause
// they must have distinct code for C51, C166 and IAR and HW...
#define FS_POS__NEAR      24
#define FS_POS__INTER     55
#define FS_POS__USING     396
#define FS_POS__FAR       351
#define FS_POS____NEAR   478
#define FS_POS____INTER  327
#define FS_POS____FAR    223

#define FSM_K (FSM_KR|FSM_ANSI|FSM_BC|FSM_MSC|FSM_C51|FSM_C166|FSM_IAR|FSM_ORG|FSM_HW_HC16|FSM_HW_851|FSM_HW_XA|FSM_HW_HC5_11_12|FSM_HW_68K|FSM_COSMIC_6805|FSM_HI_TECH_6805|FSM_TMS_370)
#define FSM_A       (FSM_ANSI|FSM_BC|FSM_MSC|FSM_C51|FSM_C166|FSM_IAR|FSM_ORG|FSM_HW_HC16|FSM_HW_851|FSM_HW_XA|FSM_HW_HC5_11_12|FSM_HW_68K|FSM_COSMIC_6805|FSM_HI_TECH_6805|FSM_TMS_370)

/*
typedef struct {
	char *name;
	int tokenClass;
	int tokenVal;
} Keyword;

static Keyword ktab[] = {
{"dummy", 0, 0 }, // this entry exists just for the proper work of binsearch
{"auto", CLASS, FS_AUTO},
{"break", BREAK, FS_NOTYPE},
{"case", CASE, FS_NOTYPE},
{"char", TYPE, FS_CHAR},
{"const",TYPE, FS_CONST},
{"continue",CONTINUE,FS_NOTYPE},
{"default",DEFAULT,FS_NOTYPE},
{"do",DO,FS_NOTYPE},
{"double",TYPE,FS_DOUBLE},
{"else",ELSE,FS_NOTYPE},
{"enum",ENUM,FS_T_ENUM},
{"extern",CLASS,FS_EXTERN},
{"float",TYPE,FS_FLOAT},
{"for",FOR,FS_NOTYPE},
{"goto",GOTO,FS_NOTYPE},
{"if",IF,FS_NOTYPE},
{"int",TYPE,FS_INT},
{"long",TYPE,FS_LONG},
{"register",CLASS,FS_REGISTER},
{"return",RETURN,FS_NOTYPE},
{"short",TYPE,FS_SHORT},
{"signed",TYPE,FS_SIGNED},
{"sizeof",SIZEOF,FS_NOTYPE},
{"static",CLASS,FS_STATIC},
{"struct",STRUCT,FS_T_STRUCT},
{"switch",SWITCH,FS_NOTYPE},
{"typedef",CLASS,FS_TYPEDEF},
{"union",STRUCT,FS_T_UNION},
{"unsigned",TYPE,FS_UNSIGNED},
{"void",TYPE,FS_VOID},
{"volatile",TYPE,FS_VOLATILE},
{"while",WHILE,FS_NOTYPE}
};
*/



FSReservedIdRec FSKeywordsHashTable[FS_IDHASHSIZE] =
{
   { NULL,          0                             },
   { "compact",     _C51_NOPAR,FS_NOTYPE,    FSM_C51         },
   { "__self",      _SELF     ,FS_NOTYPE,    FSM_MSC         },
   { NULL,          0                             },
   { "__es",        _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { "do",          DO        ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { "pdata",       _SPEC_MOD ,FS_NOTYPE,     FSM_C51         },
   { "_segname",    _SEGNAME  ,FS_NOTYPE,    FSM_MSC         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "non_banked",  _SPEC_QUAL,FS_NOTYPE,    FSM_IAR         },
   { "_ds",         _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "near",        _SPEC_MOD ,FS_NOTYPE,FSM_BC | FSM_MSC | FSM_C166 | FSM_IAR | FSM_HW_HC16 | FSM_HW_851 | FSM_HW_XA | FSM_HW_HC5_11_12 | FSM_HI_TECH_6805 |FSM_TMS_370 },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_fortran",    _SPEC_MOD ,FS_NOTYPE,FSM_BC | FSM_MSC },
   { "_asm",        _ASM      ,FS_NOTYPE,    FSM_BC | FSM_MSC },
   { "shortad",     _SPEC_QUAL,FS_NOTYPE,    FSM_IAR         },
   { "long",        TYPE      ,FS_LONG,      FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_pascal",     _SPEC_MOD ,FS_NOTYPE,FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "uni",         _HW_SPEC_QUAL,FS_NOTYPE,FSM_HW_851 | FSM_HW_XA        },
   { "__loadds",    _SPEC_MOD,FS_NOTYPE,FSM_BC | FSM_MSC },
   { "return",      RETURN    ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "interrupt",   _SPEC_MOD ,FS_NOTYPE,FSM_BC | FSM_MSC | FSM_C51 | FSM_C166 | FSM_IAR | FSM_HI_TECH_6805 },
   { "__ss",        _SPEC_MOD,FS_NOTYPE,FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "int",         TYPE      ,FS_INT,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_huge",       _SPEC_MOD ,FS_NOTYPE,FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_far16",      _SPEC_MOD,FS_NOTYPE,FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_far",        _SPEC_MOD ,FS_NOTYPE,FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { "__export",    _SPEC_MOD,FS_NOTYPE,FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "pascal",      _SPEC_MOD ,FS_NOTYPE,FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_saveregs",   _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "data",        _SPEC_MOD ,FS_NOTYPE,      FSM_C51         },
   { "asm",         _ASM      ,FS_NOTYPE,    FSM_BC | FSM_C51 | FSM_C166 | FSM_IAR | FSM_ORG | FSM_HW_HC16 | FSM_HW_851 | FSM_HW_XA | FSM_HW_HC5_11_12 | FSM_HW_68K | FSM_HI_TECH_6805 | FSM_TMS_370 },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_priority_",  _PRIORITY ,FS_NOTYPE,    FSM_C51| FSM_C166},
   { "_cs",         _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { "volatile",    CONST_VOLAT      ,FS_VOLATILE, FSM_A           },
   { "__segment",   _SEGMENT  ,FS_NOTYPE,     FSM_MSC         },
   { NULL,          0                             },
   { "while",       WHILE     ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_import",     _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { "persistent",  _HI_TECH_SPEC_QUAL,FS_NOTYPE, FSM_HI_TECH_6805},
   { NULL,          0                             },
   { "auto",        CLASS     ,FS_AUTO,       FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "large",       _C51_NOPAR,FS_NOTYPE,    FSM_C51         },
   { NULL,          0                             },
   { "__based",     _BASED    ,FS_NOTYPE,     FSM_MSC         },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__fastcall",  _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { "reentrant",   _C51_NOPAR,FS_NOTYPE,    FSM_C51         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__try",       _TRY      ,FS_NOTYPE,    FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__cdecl",     _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "small",       _C51_NOPAR,FS_NOTYPE,    FSM_C51         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_based",      _BASED    ,FS_NOTYPE,     FSM_MSC         },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_argt$",      _IAR_UNARY,FS_NOTYPE,    FSM_IAR         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_near",       _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__stdcall",   _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "const",       CONST_VOLAT      ,FS_CONST, FSM_A           },
   { "_cdecl",      _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { "zpage",       _SPEC_QUAL,FS_NOTYPE,     FSM_IAR         },
   { NULL,          0                             },
   { "__finally",   _FINALLY  ,FS_NOTYPE,    FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__far",       _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC | FSM_HI_TECH_6805 },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "monitor",     _SPEC_QUAL,FS_NOTYPE,     FSM_IAR         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_seg",        _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { "else",        ELSE      ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_args$",      _IAR_ARGS ,FS_NOTYPE,    FSM_IAR         },
   { "idata",       _SPEC_MOD ,FS_NOTYPE, FSM_C51| FSM_C166},
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "void",        TYPE      ,FS_VOID, FSM_A           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_self",       _SELF     ,FS_NOTYPE,    FSM_MSC         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_at_",        _AT       ,FS_NOTYPE,    FSM_C51         },
   { "case",        CASE      ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_es",         _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { NULL,          0                             },
   { "_fastcall",   _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { "register",    CLASS     ,FS_REGISTER,   FSM_K           },
   { NULL,          0                             },
   { "if",          IF        ,FS_NOTYPE,    FSM_K           },
   { "extern",      CLASS     ,FS_EXTERN,     FSM_K           },
   { NULL,          0                             },
   { "__thread",    _THREAD   ,FS_NOTYPE,    FSM_BC          },
   { "struct",      STRUCT    ,FS_T_STRUCT,  FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__ds",        _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "switch",      SWITCH    ,FS_NOTYPE,    FSM_K           },
   { "typedef",     CLASS     ,FS_TYPEDEF,    FSM_K           },
   { "fortran",     _SPEC_MOD ,FS_NOTYPE,     FSM_MSC         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__pascal",    _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__segname",   _SEGNAME  ,FS_NOTYPE,    FSM_MSC         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_loadds",     _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { "__interrupt", _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC | FSM_HI_TECH_6805 },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_ss",         _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { "__fortran",   _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC },
   { "break",       BREAK     ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "signed",      TYPE      ,FS_SIGNED, FSM_A           },
   { NULL,          0                             },
   { NULL,          0                             },
   { "far",         _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC | FSM_C166 | FSM_HW_HC16 | FSM_HW_851 | FSM_HW_XA | FSM_HW_HC5_11_12 | FSM_HI_TECH_6805 | FSM_TMS_370 },
   { NULL,          0                             },
   { "_export",     _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { "_segment",    _SEGMENT  ,FS_NOTYPE,     FSM_MSC         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__huge",      _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC },
   { "__far16",     _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "saddr",       _SPEC_QUAL,FS_NOTYPE,     FSM_IAR         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__cs",        _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "float",       TYPE      ,FS_FLOAT,      FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__import",    _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { "rom",         _HW_SPEC_QUAL,FS_NOTYPE,FSM_HW_851 | FSM_HW_XA        },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__seg",       _SPEC_MOD,FS_NOTYPE, FSM_BC          },
   { "using",       _USING    ,FS_NOTYPE,    FSM_C51| FSM_C166 | FSM_IAR},
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "sfr16",       _SFR16    ,FS_NOTYPE,     FSM_C51         },
   { NULL,          0                             },
   { NULL,          0                             },
   { "for",         FOR       ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "default",     DEFAULT   ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "no_init",     _SPEC_QUAL,FS_NOTYPE,     FSM_IAR         },
   { NULL,          0                             },
   { NULL,          0                             },
   { "enum",        ENUM      ,FS_T_ENUM,    FSM_A           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "double",      TYPE      ,FS_DOUBLE,     FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "static",      CLASS     ,FS_STATIC,     FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "sbit",        _SBIT     ,FS_NOTYPE, FSM_C51| FSM_C166},
   { NULL,          0                             },
   { NULL,          0                             },
   { "goto",        GOTO      ,FS_NOTYPE,    FSM_K           },
   { "_stdcall",    _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { "_opc",        _IAR_UNARY,FS_NOTYPE,    FSM_IAR         },
   { NULL,          0                             },
   { "__except",    _EXCEPT   ,FS_NOTYPE,    FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "bit",         _BIT      ,FS_NOTYPE, FSM_C51| FSM_C166 | FSM_IAR},
   { NULL,          0                             },
   { "sfr",         _SFR      ,FS_NOTYPE, FSM_C51| FSM_C166 | FSM_IAR},
   { NULL,          0                             },
   { NULL,          0                             },
   { "_interrupt",  _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { "cdecl",       _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "alien",       _SPEC_QUAL,FS_NOTYPE, FSM_C51         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "huge",        _SPEC_MOD ,FS_NOTYPE, FSM_BC | FSM_MSC | FSM_C166},
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__near",      _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC | FSM_HI_TECH_6805 },
   { NULL,          0                             },
   { NULL,          0                             },
   { "sdata",       _SPEC_MOD ,FS_NOTYPE, FSM_C166        },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__persistent", _HI_TECH_SPEC_QUAL,FS_NOTYPE, FSM_HI_TECH_6805},
   { "xdata",       _SPEC_MOD ,FS_NOTYPE,      FSM_C51         },
   { NULL,          0                             },
   { "__saveregs",  _SPEC_MOD,FS_NOTYPE, FSM_BC | FSM_MSC },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "continue",    CONTINUE  ,FS_NOTYPE,    FSM_K           },
   { NULL,          0                             },
   { "sfrp",        _SFRP     ,FS_NOTYPE,     FSM_IAR         },
   { "bdata",       _SPEC_MOD ,FS_NOTYPE, FSM_C51| FSM_C166},
   { "code",        _SPEC_MOD ,FS_NOTYPE, FSM_C51         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "inline",      _SPEC_STRG_CL,FS_NOTYPE,FSM_TMS_370},
   { NULL,          0                             },
   { "paged",       _HW_SPEC_QUAL,FS_NOTYPE,FSM_HW_851       },
   { NULL,          0                             },
   { "union",       STRUCT    ,FS_T_UNION,   FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "_task_",      _TASK     ,FS_NOTYPE,    FSM_C51| FSM_C166},
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__asm",       _ASM      ,FS_NOTYPE,    FSM_BC | FSM_MSC },
   { "char",        TYPE      ,FS_CHAR,       FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { "__inline",    _SPEC_MOD ,FS_NOTYPE,     FSM_MSC         },
   { NULL,          0                             },
   { "unsigned",    TYPE      ,FS_UNSIGNED,   FSM_K           },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { "short",       TYPE      ,FS_SHORT,      FSM_K           },
   { NULL,          0                             },
   { "_emit",       _EMIT     ,FS_NOTYPE,    FSM_MSC         },
   { NULL,          0                             },
   { "sizeof",      SIZEOF    ,FS_NOTYPE,    FSM_K           },
   { "banked",      _SPEC_QUAL,FS_NOTYPE,     FSM_IAR         },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             },
   { NULL,          0                             }
};

//##ModelId=419A04D601CD
Boolean FSReservedIdRec::Active()
{
   return ( Boolean )( ( fsAnlzOptions.GetMode() & TokenFlags ) != 0 );
};

/*
static int id_or_keyword(char *lex ) { // uses ktab
    unsigned low = 1;
    unsigned high = sizeof(ktab)/sizeof(Keyword)-1;
    unsigned middle;
    int cp;
    while(low<=high) {
       middle= (high+low)/2;
       if ((cp=strcmp(lex,ktab[middle].name))==0) break;
       else if (cp<0) high=middle-1;
       else low=middle+1;
    }
    if (low<=high) {
      yylval.spec=(FSBaseTypeSpecifiers) (ktab[middle].tokenVal);
      return ktab[middle].tokenClass;
    }
    else if (typDfAllowed &&
             fsSymTable->LookUp(yytext,&(yylval.ptrSym)) == TRUE &&
             ( (FSBaseType *)(yylval.ptrSym->GetType()->GetBaseType()) )
                             -> GetSpecifier(FS_TYPEDEF)) {
             return TTYPE;
         }
    else {
      yylval.ptrChar = strcpy(new char[yyleng+1],yytext);
      return NAME;
    }
}
*/

static int id_or_keyword( char *lex )
{
    unsigned short Hash = 0; // 16 bit always on PC & BC45
    char *pp = lex;
    while ( *pp )
    {
       Hash = ( unsigned short )FS_IDHASHSTEP( Hash, *( pp++ ) );
    }
    // Try to recognize a keyword.  Uses minimum-perfect hash
    // function
    FSReservedIdRec *ph = &FSKeywordsHashTable[ Hash % FS_IDHASHSIZE];
    if (    ph->Keyword != NULL
         && strcmp( lex, ph->Keyword ) == 0
         && ph->Active()
       )
    {
      yylval.spec=(FSBaseTypeSpecifiers) (ph->tokenVal);
      return ph->tokenClass;
    }
    //else if (    typDfAllowed
    //          && fsSymTable->LookUp(yytext,&(yylval.ptrSym)) == TRUE
    //          && ( (FSBaseType *)(yylval.ptrSym->GetType()->GetBaseType()) )
    //                         -> GetSpecifier(FS_TYPEDEF)
    //        )
    //{
    //        return TTYPE;
    //}
    else
    {
      yylval.ptrChar = strcpy(new char[yyleng+1],yytext);
      return NAME;
    }
}

// used for backtracking over RC in MSC asm which ends on NEWLINE or RC excluding it
static Boolean fsLexRCTokenIsSaved;

void FSLexInit()
{
/* DB */ // bilo bi krajnje vreme da se ovo uradi sa switch-om
      fsLexRCTokenIsSaved = FALSE;
    FSKeywordsHashTable[FS_POS__FAR].tokenClass = _SPEC_MOD;
    FSKeywordsHashTable[FS_POS__NEAR].tokenClass = _SPEC_MOD;

    FSKeywordsHashTable[FS_POS____FAR].tokenClass = _SPEC_MOD;
    FSKeywordsHashTable[FS_POS____NEAR].tokenClass = _SPEC_MOD;
    FSKeywordsHashTable[FS_POS____INTER].tokenClass = _SPEC_MOD;

    if ( fsAnlzOptions.GetMode() == FSM_C51 ||
                     fsAnlzOptions.GetMode() == FSM_C166 )
    {
       FSKeywordsHashTable[FS_POS__INTER].tokenClass = _C51_166_INT;
       FSKeywordsHashTable[FS_POS__USING].tokenClass = _USING;
    }
    else
    {
       FSKeywordsHashTable[FS_POS__INTER].tokenClass = _SPEC_MOD;
       if ( fsAnlzOptions.GetMode() == FSM_IAR )
       {
          FSKeywordsHashTable[FS_POS__INTER].tokenClass = _IAR_INT;
          FSKeywordsHashTable[FS_POS__NEAR].tokenClass = _SPEC_QUAL;
          FSKeywordsHashTable[FS_POS__USING].tokenClass = _IAR_USING;
       }
    }
    if (    fsAnlzOptions.GetMode() == FSM_HW_HC16
         || fsAnlzOptions.GetMode() == FSM_HW_851
         || fsAnlzOptions.GetMode() == FSM_HW_XA
         || fsAnlzOptions.GetMode() == FSM_HW_HC5_11_12
       )
    {
          FSKeywordsHashTable[FS_POS__NEAR].tokenClass = _HW_SPEC_QUAL;
          FSKeywordsHashTable[FS_POS__FAR].tokenClass = _HW_SPEC_QUAL;
    }
    if ( fsAnlzOptions.GetMode() == FSM_HI_TECH_6805 )
    {
       FSKeywordsHashTable[FS_POS__FAR].tokenClass = _HI_TECH_SPEC_QUAL;
       FSKeywordsHashTable[FS_POS__NEAR].tokenClass = _HI_TECH_SPEC_QUAL;
       FSKeywordsHashTable[FS_POS__INTER].tokenClass = _HI_TECH_SPEC_QUAL;
       FSKeywordsHashTable[FS_POS____FAR].tokenClass = _HI_TECH_SPEC_QUAL;
       FSKeywordsHashTable[FS_POS____NEAR].tokenClass = _HI_TECH_SPEC_QUAL;
       FSKeywordsHashTable[FS_POS____INTER].tokenClass = _HI_TECH_SPEC_QUAL;
    }
    if ( fsAnlzOptions.GetMode() == FSM_TMS_370 )
    {
       FSKeywordsHashTable[FS_POS__NEAR].tokenClass = _SPEC_STRG_CL;
       FSKeywordsHashTable[FS_POS__FAR].tokenClass = _SPEC_STRG_CL;
    }
}

#define NEXT_TOKEN \
          do { \
            token = preProc->GetToken(); \
            yytext = preProc->outBuffer.yytext; \
            yyleng = preProc->outBuffer.yyleng; \
          } while(0)

int yylex()
{
   int token;
   if ( fsLexRCTokenIsSaved )
   {
      fsLexRCTokenIsSaved = FALSE;
      *yytext = '}';
      return RC;
   }

LexLoopStart:
   NEXT_TOKEN;
   if ( token == NAME ) token = id_or_keyword( yytext );
   if ( token != _ASM && token != _ASM_START ) return token;

   // token == _ASM for all compilers except for HI-TECH
   switch ( fsAnlzOptions.GetMode() )
   {
      // finite state machine for MSC
      case FSM_MSC:
         preProc->passThroughNewline = TRUE;
         preProc->tokenizer.recognizeAsmComments = TRUE;
         MSC_INITIAL:
            NEXT_TOKEN;
            switch( token )
            {
               case LC:
                  goto MSC_WITH_LCRC;

               case NEWLINE:
                  goto MSC_INITIAL;

               case RC:
                  fsLexRCTokenIsSaved = TRUE;
                  goto ASM_EXIT;

               case EOF:
                  goto ASM_EXIT;

               default:
                  goto MSC_WITHOUT_LCRC;
            }
         MSC_WITHOUT_LCRC:
            NEXT_TOKEN;
            switch( token )
            {
               case RC:
                  fsLexRCTokenIsSaved = TRUE;
                  goto ASM_EXIT;

               case NEWLINE:
               case EOF:
                  goto ASM_EXIT;

               default:
                  goto MSC_WITHOUT_LCRC;
            }
         MSC_WITH_LCRC:
            NEXT_TOKEN;
            switch( token )
            {
               case RC:
                  goto ASM_EXIT;

               case EOF:
                  goto ASM_EXIT;

               default:
                  goto MSC_WITH_LCRC;
            }

      // finite state machine for BC
      case FSM_BC:
         preProc->passThroughNewline = TRUE;
         BC_INITIAL:
            NEXT_TOKEN;
            switch( token )
            {
               case LC:
                  goto BC_WITH_LCRC;

               case NEWLINE:
                  goto ASM_EXIT; // for BC31
                  //goto BC_INITIAL; for BC45

               case SEMI:
               case EOF:
                  goto ASM_EXIT;

               default:
                  goto BC_WITHOUT_LCRC;
            }
         BC_WITHOUT_LCRC:
            NEXT_TOKEN;
            switch( token )
            {
               case NEWLINE:
               case EOF:
               case SEMI:
                  goto ASM_EXIT;

               default:
                  goto BC_WITHOUT_LCRC;
            }
         BC_WITH_LCRC:
            NEXT_TOKEN;
            switch( token )
            {
               case RC:
                  goto ASM_EXIT;

               case EOF:
                  goto ASM_EXIT;

               default:
                  goto BC_WITH_LCRC;
            }

      // finite state machine for HIWARE
      case FSM_HW_HC5_11_12:
      case FSM_HW_HC16:
      case FSM_HW_851:
      case FSM_HW_XA:
      case FSM_HW_68K:
         preProc->passThroughNewline = TRUE;
         preProc->tokenizer.recognizeAsmComments = TRUE;
         HW_INITIAL:
            NEXT_TOKEN;
            switch( token )
            {
               case LC:
                  goto HW_WITH_LCRC;

               case NEWLINE:
                  goto HW_INITIAL;

               case SEMI:
               case EOF:
                  goto ASM_EXIT;

               default:
                  goto HW_WITHOUT_LCRC;
            }
         HW_WITHOUT_LCRC:
            NEXT_TOKEN;
            switch( token )
            {
               case NEWLINE:
               case SEMI:
               case EOF:
                  goto ASM_EXIT;

               default:
                  goto HW_WITHOUT_LCRC;
            }
         HW_WITH_LCRC:
            NEXT_TOKEN;
            switch( token )
            {
               case RC:
               case EOF:
                  goto ASM_EXIT;

               default:
                  goto HW_WITH_LCRC;
            }

      // finite state machine for HI-TECH
      case FSM_HI_TECH_6805:
            if ( token == _ASM ) return _HI_TECH_ASM;
            // token == _ASM_START from #asm
            preProc->tokenizer.recognizeAsmComments = TRUE;
         HI_TECH_INITIAL:
            NEXT_TOKEN;
            switch( token )
            {
               case _ASM_END:
               case EOF:
                  preProc->tokenizer.recognizeAsmComments = FALSE;
                  goto LexLoopStart;

               default:
                  goto HI_TECH_INITIAL;
            }

      // finite state machine for TMS 370
      case FSM_TMS_370:
            return _HI_TECH_ASM;

      // default: bug
   }
ASM_EXIT:
//   preProc->passThroughNewline = FALSE;
   preProc->tokenizer.recognizeAsmComments = FALSE;
   *yytext = '\0';
   return _ASM;
}
